Index: src/bin/pg_dump/pg_dump.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/bin/pg_dump/pg_dump.c,v
retrieving revision 1.266
diff -c -r1.266 pg_dump.c
*** src/bin/pg_dump/pg_dump.c	2002/06/13 20:02:31	1.266
--- src/bin/pg_dump/pg_dump.c	2002/06/15 16:39:20
***************
*** 108,113 ****
--- 108,114 ----
  					const char *acl, const char *objoid);
  
  static void dumpTriggers(Archive *fout, TableInfo *tblinfo, int numTables);
+ static void dumpConstraints(Archive *fout, TableInfo *tblinfo, int numTables);
  static void dumpRules(Archive *fout, TableInfo *tblinfo, int numTables);
  static void formatStringLiteral(PQExpBuffer buf, const char *str,
  								const formatLiteralOptions opts);
***************
*** 614,619 ****
--- 615,621 ----
  	{
  		dumpTriggers(g_fout, tblinfo, numTables);
  		dumpRules(g_fout, tblinfo, numTables);
+ 		dumpConstraints(g_fout, tblinfo, numTables);
  	}
  
  	/* Now sort the output nicely */
***************
*** 3326,3331 ****
--- 3328,3334 ----
  	}
  }
  
+ 
  /*
   * format_function_signature: generate function name and argument list
   *
***************
*** 4636,4643 ****
  		if (tbinfo->ncheck > 0)
  		{
  			PGresult   *res2;
! 			int			i_rcname,
! 						i_rcsrc;
  			int			ntups2;
  
  			if (g_verbose)
--- 4639,4646 ----
  		if (tbinfo->ncheck > 0)
  		{
  			PGresult   *res2;
! 			int			i_conname,
! 						i_consrc;
  			int			ntups2;
  
  			if (g_verbose)
***************
*** 4646,4669 ****
  
  			resetPQExpBuffer(query);
  			if (g_fout->remoteVersion >= 70300)
! 				appendPQExpBuffer(query, "SELECT rcname, rcsrc"
! 								  " from pg_catalog.pg_relcheck c1"
! 								  " where rcrelid = '%s'::pg_catalog.oid "
  								  "   and not exists "
  								  "  (select 1 from "
! 								  "    pg_catalog.pg_relcheck c2, "
  								  "    pg_catalog.pg_inherits i "
! 								  "    where i.inhrelid = c1.rcrelid "
! 								  "      and (c2.rcname = c1.rcname "
! 								  "          or (c2.rcname[0] = '$' "
! 								  "              and c1.rcname[0] = '$')"
! 								  "          )"
! 								  "      and c2.rcsrc = c1.rcsrc "
! 								  "      and c2.rcrelid = i.inhparent) "
! 								  " order by rcname ",
  								  tbinfo->oid);
  			else
! 				appendPQExpBuffer(query, "SELECT rcname, rcsrc"
  								  " from pg_relcheck c1"
  								  " where rcrelid = '%s'::oid "
  								  "   and not exists "
--- 4649,4669 ----
  
  			resetPQExpBuffer(query);
  			if (g_fout->remoteVersion >= 70300)
! 				appendPQExpBuffer(query, "SELECT conname, consrc"
! 								  " from pg_catalog.pg_constraint c1"
! 								  " where conrelid = '%s'::pg_catalog.oid "
! 								  "   and contype = 'c' "
  								  "   and not exists "
  								  "  (select 1 from "
! 								  "    pg_catalog.pg_constraint c2, "
  								  "    pg_catalog.pg_inherits i "
! 								  "    where i.inhrelid = c1.conrelid "
! 								  "      and c2.conname = c1.conname "
! 								  "      and c2.conrelid = i.inhparent) "
! 								  " order by conname ",
  								  tbinfo->oid);
  			else
! 				appendPQExpBuffer(query, "SELECT rcname as conname, rcsrc as consrc"
  								  " from pg_relcheck c1"
  								  " where rcrelid = '%s'::oid "
  								  "   and not exists "
***************
*** 4678,4683 ****
--- 4678,4684 ----
  								  "      and c2.rcrelid = i.inhparent) "
  								  " order by rcname ",
  								  tbinfo->oid);
+ 
  			res2 = PQexec(g_conn, query->data);
  			if (!res2 ||
  				PQresultStatus(res2) != PGRES_TUPLES_OK)
***************
*** 4694,4706 ****
  				exit_nicely();
  			}
  
! 			i_rcname = PQfnumber(res2, "rcname");
! 			i_rcsrc = PQfnumber(res2, "rcsrc");
  
  			for (j = 0; j < ntups2; j++)
  			{
! 				const char *name = PQgetvalue(res2, j, i_rcname);
! 				const char *expr = PQgetvalue(res2, j, i_rcsrc);
  
  				if (actual_atts + j > 0)
  					appendPQExpBuffer(q, ",\n\t");
--- 4695,4707 ----
  				exit_nicely();
  			}
  
! 			i_conname = PQfnumber(res2, "conname");
! 			i_consrc = PQfnumber(res2, "consrc");
  
  			for (j = 0; j < ntups2; j++)
  			{
! 				const char *name = PQgetvalue(res2, j, i_conname);
! 				const char *expr = PQgetvalue(res2, j, i_consrc);
  
  				if (actual_atts + j > 0)
  					appendPQExpBuffer(q, ",\n\t");
***************
*** 5226,5231 ****
--- 5227,5334 ----
  	destroyPQExpBuffer(delqry);
  }
  
+ /*
+  * dumpConstraints
+  *
+  * Dump out constraints after all table creation statements in
+  * an alter table format.  Currently handles foreign keys only.
+  *
+  * XXX Potentially wrap in a 'SET CONSTRAINTS OFF' block so that
+  * the current table data is not processed
+  */
+ static void
+ dumpConstraints(Archive *fout, TableInfo *tblinfo, int numTables)
+ {
+ 	int			i,
+ 				j;
+ 	PQExpBuffer query = createPQExpBuffer();
+ 	PQExpBuffer delqry = createPQExpBuffer();
+ 	PGresult   *res;
+ 	int			i_condef,
+ 				i_conoid,
+ 				i_conname;
+ 	int			ntups;
+ 
+ 	/* pg_constraint was created in 7.3 */
+ 	if (g_fout->remoteVersion >= 70300)
+ 	{
+ 
+ 		for (i = 0; i < numTables; i++)
+ 		{
+ 			TableInfo	   *tbinfo = &tblinfo[i];
+ 
+ 			if (tbinfo->ntrig == 0 || !tbinfo->dump)
+ 				continue;
+ 
+ 			if (g_verbose)
+ 				write_msg(NULL, "dumping triggers for table %s\n",
+ 						  tbinfo->relname);
+ 
+ 			/* select table schema to ensure regproc name is qualified if needed */
+ 			selectSourceSchema(tbinfo->relnamespace->nspname);
+ 
+ 			resetPQExpBuffer(query);
+ 			appendPQExpBuffer(query,
+ 							  "SELECT pg_get_fkeydef(conrelid, conname) as condef, "
+ 							  "oid, conname "
+ 							  "from pg_catalog.pg_constraint "
+ 							  "where conrelid = '%s'::pg_catalog.oid "
+ 							  "and contype = 'f'",
+ 							  tbinfo->oid);
+ 			res = PQexec(g_conn, query->data);
+ 			if (!res ||
+ 				PQresultStatus(res) != PGRES_TUPLES_OK)
+ 			{
+ 				write_msg(NULL, "query to obtain list of foreign key definitions failed: %s", PQerrorMessage(g_conn));
+ 				exit_nicely();
+ 			}
+ 			ntups = PQntuples(res);
+ 
+ 			i_condef = PQfnumber(res, "condef");
+ 			i_conoid = PQfnumber(res, "oid");
+ 			i_conname = PQfnumber(res, "conname");
+ 	
+ 			for (j = 0; j < ntups; j++)
+ 			{
+ 				const char *conName = PQgetvalue(res, j, i_conname);
+ 				const char *conOid = PQgetvalue(res, j, i_conoid);
+ 				const char *conDef = PQgetvalue(res, j, i_condef);
+ 
+ 				resetPQExpBuffer(query);
+ 				/*
+ 				 * Creation query is built by pg_get_fkeydef.
+ 				 * We don't need to DROP Foreign keys as the
+ 				 * table drop will take care of that.
+ 				 */
+ 				appendPQExpBuffer(query, "%s;",
+ 								  conDef);
+ 
+ 				ArchiveEntry(fout, conOid,
+ 							 conName,
+ 							 tbinfo->relnamespace->nspname,
+ 							 tbinfo->usename,
+ 							 "CONSTRAINT", NULL,
+ 							 query->data, delqry->data,
+ 							 NULL, NULL, NULL);
+ 
+ 				resetPQExpBuffer(query);
+ 				appendPQExpBuffer(query, "CONSTRAINT %s ",
+ 								  fmtId(conName, force_quotes));
+ 				appendPQExpBuffer(query, "ON %s",
+ 								  fmtId(tbinfo->relname, force_quotes));
+ 
+ 				dumpComment(fout, query->data,
+ 							tbinfo->relnamespace->nspname, tbinfo->usename,
+ 							conOid, "pg_constraint", 0, NULL);
+ 			}
+ 
+ 			PQclear(res);
+ 		}
+ 	}
+ 	destroyPQExpBuffer(query);
+ 	destroyPQExpBuffer(delqry);
+ }
+ 
  
  static void
  dumpTriggers(Archive *fout, TableInfo *tblinfo, int numTables)
***************
*** 5274,5280 ****
  							  "tgconstrrelid, tginitdeferred, oid, "
  							  "tgconstrrelid::pg_catalog.regclass as tgconstrrelname "
  							  "from pg_catalog.pg_trigger "
! 							  "where tgrelid = '%s'::pg_catalog.oid",
  							  tbinfo->oid);
  		}
  		else
--- 5377,5384 ----
  							  "tgconstrrelid, tginitdeferred, oid, "
  							  "tgconstrrelid::pg_catalog.regclass as tgconstrrelname "
  							  "from pg_catalog.pg_trigger "
! 							  "where tgrelid = '%s'::pg_catalog.oid "
! 							  "and tgisconstraint is false",
  							  tbinfo->oid);
  		}
  		else
***************
*** 5297,5309 ****
  			write_msg(NULL, "query to obtain list of triggers failed: %s", PQerrorMessage(g_conn));
  			exit_nicely();
  		}
  		ntups = PQntuples(res);
! 		if (ntups != tbinfo->ntrig)
  		{
  			write_msg(NULL, "expected %d triggers on table \"%s\" but found %d\n",
  					  tbinfo->ntrig, tbinfo->relname, ntups);
  			exit_nicely();
  		}
  		i_tgname = PQfnumber(res, "tgname");
  		i_tgfname = PQfnumber(res, "tgfname");
  		i_tgtype = PQfnumber(res, "tgtype");
--- 5401,5419 ----
  			write_msg(NULL, "query to obtain list of triggers failed: %s", PQerrorMessage(g_conn));
  			exit_nicely();
  		}
+ 
  		ntups = PQntuples(res);
! 		/*
! 		 * We may have less triggers than recorded due to constraint triggers
! 		 * which are dumped by dumpConstraints
! 		 */
! 		if (ntups > tbinfo->ntrig)
  		{
  			write_msg(NULL, "expected %d triggers on table \"%s\" but found %d\n",
  					  tbinfo->ntrig, tbinfo->relname, ntups);
  			exit_nicely();
  		}
+ 
  		i_tgname = PQfnumber(res, "tgname");
  		i_tgfname = PQfnumber(res, "tgfname");
  		i_tgtype = PQfnumber(res, "tgtype");
Index: src/bin/psql/command.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/bin/psql/command.c,v
retrieving revision 1.72
diff -c -r1.72 command.c
*** src/bin/psql/command.c	2002/04/24 05:24:00	1.72
--- src/bin/psql/command.c	2002/06/15 16:39:23
***************
*** 355,360 ****
--- 355,363 ----
  			case 'a':
  				success = describeAggregates(name);
  				break;
+ 			case 'c':
+ 				//success = describeConstraint(name);
+ 				break;
  			case 'd':
  				success = objectDescription(name);
  				break;
Index: src/bin/psql/describe.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/bin/psql/describe.c,v
retrieving revision 1.54
diff -c -r1.54 describe.c
*** src/bin/psql/describe.c	2002/05/13 17:45:30	1.54
--- src/bin/psql/describe.c	2002/06/15 16:39:27
***************
*** 396,402 ****
  
  			 ") AS tt,\n"
  			 "pg_description d\n"
! 			 "WHERE tt.oid = d.objoid and tt.tableoid = d.classoid and d.objsubid = 0\n",
  
  			 _("Name"), _("Object"), _("Description"),
  			 _("aggregate"), _("function"), _("operator"),
--- 396,403 ----
  
  			 ") AS tt,\n"
  			 "pg_description d\n"
! 			 "WHERE t.tgisconstraint IS FALSE\n"
! 			 "AND tt.oid = d.objoid and tt.tableoid = d.classoid and d.objsubid = 0\n",
  
  			 _("Name"), _("Object"), _("Description"),
  			 _("aggregate"), _("function"), _("operator"),
***************
*** 745,753 ****
  		PGresult   *result1 = NULL,
  				   *result2 = NULL,
  				   *result3 = NULL,
! 				   *result4 = NULL;
! 		int			index_count = 0,
! 					constr_count = 0,
  					rule_count = 0,
  					trigger_count = 0;
  		int			count_footers = 0;
--- 746,756 ----
  		PGresult   *result1 = NULL,
  				   *result2 = NULL,
  				   *result3 = NULL,
! 				   *result4 = NULL,
! 				   *result5 = NULL;
! 		int			constr_count = 0,
! 					index_count = 0,
! 					foreignkey_count = 0,
  					rule_count = 0,
  					trigger_count = 0;
  		int			count_footers = 0;
***************
*** 774,782 ****
  		if (tableinfo.checks)
  		{
  			printfPQExpBuffer(&buf,
! 					"SELECT rcsrc, rcname\n"
! 					"FROM pg_relcheck r, pg_class c\n"
! 					"WHERE c.relname='%s' AND c.oid = r.rcrelid",
  					name);
  			result2 = PSQLexec(buf.data);
  			if (!result2)
--- 777,786 ----
  		if (tableinfo.checks)
  		{
  			printfPQExpBuffer(&buf,
! 					"SELECT consrc, conname\n"
! 					"FROM pg_constraint r, pg_class c\n"
! 					"WHERE c.relname='%s' AND c.oid = r.conrelid\n"
! 					"AND contype = 'c'",
  					name);
  			result2 = PSQLexec(buf.data);
  			if (!result2)
***************
*** 800,812 ****
  				rule_count = PQntuples(result3);
  		}
  
! 		/* count triggers */
  		if (tableinfo.triggers)
  		{
  			printfPQExpBuffer(&buf,
  					"SELECT t.tgname\n"
  					"FROM pg_trigger t, pg_class c\n"
! 					"WHERE c.relname='%s' AND c.oid = t.tgrelid",
  					name);
  			result4 = PSQLexec(buf.data);
  			if (!result4)
--- 804,817 ----
  				rule_count = PQntuples(result3);
  		}
  
! 		/* count triggers but ignore foreign key triggers */
  		if (tableinfo.triggers)
  		{
  			printfPQExpBuffer(&buf,
  					"SELECT t.tgname\n"
  					"FROM pg_trigger t, pg_class c\n"
! 					"WHERE t.tgisconstraint IS FALSE\n"
! 					"AND c.relname='%s' AND c.oid = t.tgrelid",
  					name);
  			result4 = PSQLexec(buf.data);
  			if (!result4)
***************
*** 815,820 ****
--- 820,839 ----
  				trigger_count = PQntuples(result4);
  		}
  
+ 		/* Fetch the Foreign Key information */
+ 		printfPQExpBuffer(&buf,
+ 					"SELECT conname,\n"
+ 					"SUBSTR(pg_get_fkeydef(16640, 'constraint_1'), POSITION('FOREIGN KEY' in pg_get_fkeydef(16640, 'constraint_1'))) as condef\n"
+ 					"FROM pg_class as c JOIN pg_constraint ON (c.oid = conrelid)\n"
+ 					"WHERE c.relname = '%s' AND contype = 'f'",
+ 					name);
+ 		result5 = PSQLexec(buf.data);
+ 		if (!result5)
+ 			goto error_return;
+ 		else
+ 			foreignkey_count = PQntuples(result5);
+ 
+ 
  		footers = xmalloc((index_count + constr_count + rule_count + trigger_count + 1)
  						  * sizeof(*footers));
  
***************
*** 846,852 ****
  		}
  
  
! 		/* print constraints */
  		for (i = 0; i < constr_count; i++)
  		{
  			char	   *s = _("Check constraints");
--- 865,871 ----
  		}
  
  
! 		/* print check constraints */
  		for (i = 0; i < constr_count; i++)
  		{
  			char	   *s = _("Check constraints");
***************
*** 863,868 ****
--- 882,906 ----
  								  PQgetvalue(result2, i, 0));
  			footers[count_footers++] = xstrdup(buf.data);
  		}
+ 
+ 		/* print foreign key constraints */
+ 		for (i = 0; i < foreignkey_count; i++)
+ 		{
+ 			char	   *s = _("Foreign Key constraints:");
+ 
+ 			if (i == 0)
+ 				printfPQExpBuffer(&buf, _("%s: %s %s"),
+ 								  s,
+ 								  PQgetvalue(result5, i, 0),
+ 								  PQgetvalue(result5, i, 1));
+ 			else
+ 				printfPQExpBuffer(&buf, _("%*s: %s %s"),
+ 								  (int) strlen(s), "",
+ 								  PQgetvalue(result5, i, 0),
+ 								  PQgetvalue(result5, i, 1));
+ 			footers[count_footers++] = xstrdup(buf.data);
+ 		}
+ 
  
  		/* print rules */
  		for (i = 0; i < rule_count; i++)
Index: src/include/postgres.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/postgres.h,v
retrieving revision 1.57
diff -c -r1.57 postgres.h
*** src/include/postgres.h	2002/04/27 21:24:34	1.57
--- src/include/postgres.h	2002/06/15 16:39:27
***************
*** 597,608 ****
--- 597,613 ----
  #define CATALOG(x)	typedef struct CppConcat(FormData_,x)
  
  #define BOOTSTRAP
+ 
+ #define BKI_PINWRITE
+ 
  #define BKI_SHARED_RELATION
+ 
  #define BKI_WITHOUT_OIDS
  
  /* these need to expand into some harmless, repeatable declaration */
  #define DATA(x)   extern int errno
  #define DESCR(x)  extern int errno
+ #define PINTABLE(x)   extern int errno
  
  #define BKI_BEGIN
  #define BKI_END
Index: src/include/access/tupdesc.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/access/tupdesc.h,v
retrieving revision 1.34
diff -c -r1.34 tupdesc.h
*** src/include/access/tupdesc.h	2002/03/29 19:06:16	1.34
--- src/include/access/tupdesc.h	2002/06/15 16:39:27
***************
*** 43,49 ****
  
  /*
   * This structure contains all information (i.e. from Classes
!  * pg_attribute, pg_attrdef, pg_relcheck) for a tuple.
   */
  typedef struct tupleDesc
  {
--- 43,49 ----
  
  /*
   * This structure contains all information (i.e. from Classes
!  * pg_attribute, pg_attrdef, pg_constraint) for a tuple.
   */
  typedef struct tupleDesc
  {
Index: src/include/catalog/catname.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/catalog/catname.h,v
retrieving revision 1.25
diff -c -r1.25 catname.h
*** src/include/catalog/catname.h	2002/04/27 21:24:34	1.25
--- src/include/catalog/catname.h	2002/06/15 16:39:28
***************
*** 20,26 ****
--- 20,28 ----
  #define  AccessMethodOperatorRelationName "pg_amop"
  #define  AccessMethodProcedureRelationName "pg_amproc"
  #define  AttributeRelationName "pg_attribute"
+ #define  ConstraintRelationName "pg_constraint"
  #define  DatabaseRelationName "pg_database"
+ #define  DependRelationName "pg_depend"
  #define  DescriptionRelationName "pg_description"
  #define  GroupRelationName "pg_group"
  #define  IndexRelationName "pg_index"
***************
*** 39,45 ****
  #define  TypeRelationName "pg_type"
  #define  VersionRelationName "pg_version"
  #define  AttrDefaultRelationName "pg_attrdef"
- #define  RelCheckRelationName "pg_relcheck"
  #define  TriggerRelationName "pg_trigger"
  
  #endif   /* CATNAME_H */
--- 41,46 ----
Index: src/include/catalog/heap.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/catalog/heap.h,v
retrieving revision 1.50
diff -c -r1.50 heap.h
*** src/include/catalog/heap.h	2002/04/27 21:24:34	1.50
--- src/include/catalog/heap.h	2002/06/15 16:39:28
***************
*** 44,50 ****
  						 bool relhasoids,
  						 bool allow_system_table_mods);
  
! extern void heap_drop_with_catalog(Oid rid, bool allow_system_table_mods);
  
  extern void heap_truncate(Oid rid);
  
--- 44,50 ----
  						 bool relhasoids,
  						 bool allow_system_table_mods);
  
! extern void heap_drop_with_catalog(Oid rid, bool allow_system_table_mods, int behavior);
  
  extern void heap_truncate(Oid rid);
  
Index: src/include/catalog/index.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/catalog/index.h,v
retrieving revision 1.47
diff -c -r1.47 index.h
*** src/include/catalog/index.h	2002/03/31 06:26:32	1.47
--- src/include/catalog/index.h	2002/06/15 16:39:28
***************
*** 37,43 ****
  			 bool primary,
  			 bool allow_system_table_mods);
  
! extern void index_drop(Oid indexId);
  
  extern IndexInfo *BuildIndexInfo(Form_pg_index indexStruct);
  
--- 37,43 ----
  			 bool primary,
  			 bool allow_system_table_mods);
  
! extern void index_drop(Oid indexId, int behavior);
  
  extern IndexInfo *BuildIndexInfo(Form_pg_index indexStruct);
  
Index: src/include/catalog/indexing.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/catalog/indexing.h,v
retrieving revision 1.66
diff -c -r1.66 indexing.h
*** src/include/catalog/indexing.h	2002/04/19 16:36:08	1.66
--- src/include/catalog/indexing.h	2002/06/15 16:39:28
***************
*** 27,33 ****
--- 27,35 ----
  #define Num_pg_attr_indices			2
  #define Num_pg_attrdef_indices		1
  #define Num_pg_class_indices		2
+ #define Num_pg_constraint_indices	2
  #define Num_pg_database_indices		2
+ #define Num_pg_depend_indices		2
  #define Num_pg_description_indices	1
  #define Num_pg_group_indices		2
  #define Num_pg_index_indices		2
***************
*** 38,44 ****
  #define Num_pg_opclass_indices		2
  #define Num_pg_operator_indices		2
  #define Num_pg_proc_indices			2
- #define Num_pg_relcheck_indices		1
  #define Num_pg_rewrite_indices		2
  #define Num_pg_shadow_indices		2
  #define Num_pg_statistic_indices	1
--- 40,45 ----
***************
*** 59,66 ****
--- 60,71 ----
  #define AttributeRelidNumIndex		"pg_attribute_relid_attnum_index"
  #define ClassNameNspIndex			"pg_class_relname_nsp_index"
  #define ClassOidIndex				"pg_class_oid_index"
+ #define ConstraintOidIndex			"pg_constraint_oid_index"
+ #define ConstraintRelidNameIndex	"pg_constraint_relid_name_index"
  #define DatabaseNameIndex			"pg_database_datname_index"
  #define DatabaseOidIndex			"pg_database_oid_index"
+ #define DependDependerIndex			"pg_depend_depender_index"
+ #define DependDependeeIndex			"pg_depend_dependee_index"
  #define DescriptionObjIndex			"pg_description_o_c_o_index"
  #define GroupNameIndex				"pg_group_name_index"
  #define GroupSysidIndex				"pg_group_sysid_index"
***************
*** 78,84 ****
  #define OperatorOidIndex			"pg_operator_oid_index"
  #define ProcedureNameNspIndex		"pg_proc_proname_args_nsp_index"
  #define ProcedureOidIndex			"pg_proc_oid_index"
- #define RelCheckIndex				"pg_relcheck_rcrelid_index"
  #define RewriteOidIndex				"pg_rewrite_oid_index"
  #define RewriteRelRulenameIndex		"pg_rewrite_rel_rulename_index"
  #define ShadowNameIndex				"pg_shadow_usename_index"
--- 83,88 ----
***************
*** 99,105 ****
--- 103,111 ----
  extern char *Name_pg_attr_indices[];
  extern char *Name_pg_attrdef_indices[];
  extern char *Name_pg_class_indices[];
+ extern char *Name_pg_constraint_indices[];
  extern char *Name_pg_database_indices[];
+ extern char *Name_pg_depend_indices[];
  extern char *Name_pg_description_indices[];
  extern char *Name_pg_group_indices[];
  extern char *Name_pg_index_indices[];
***************
*** 110,116 ****
  extern char *Name_pg_opclass_indices[];
  extern char *Name_pg_operator_indices[];
  extern char *Name_pg_proc_indices[];
- extern char *Name_pg_relcheck_indices[];
  extern char *Name_pg_rewrite_indices[];
  extern char *Name_pg_shadow_indices[];
  extern char *Name_pg_statistic_indices[];
--- 116,121 ----
***************
*** 155,160 ****
--- 160,167 ----
  DECLARE_UNIQUE_INDEX(pg_attribute_relid_attnum_index on pg_attribute using btree(attrelid oid_ops, attnum int2_ops));
  DECLARE_UNIQUE_INDEX(pg_class_oid_index on pg_class using btree(oid oid_ops));
  DECLARE_UNIQUE_INDEX(pg_class_relname_nsp_index on pg_class using btree(relname name_ops, relnamespace oid_ops));
+ DECLARE_UNIQUE_INDEX(pg_constraint_oid_index on pg_constraint using btree(oid oid_ops));
+ DECLARE_UNIQUE_INDEX(pg_constraint_relid_name_index on pg_constraint using btree(conrelid oid_ops, conname name_ops));
  DECLARE_UNIQUE_INDEX(pg_database_datname_index on pg_database using btree(datname name_ops));
  DECLARE_UNIQUE_INDEX(pg_database_oid_index on pg_database using btree(oid oid_ops));
  DECLARE_UNIQUE_INDEX(pg_description_o_c_o_index on pg_description using btree(objoid oid_ops, classoid oid_ops, objsubid int4_ops));
***************
*** 176,182 ****
  DECLARE_UNIQUE_INDEX(pg_proc_oid_index on pg_proc using btree(oid oid_ops));
  DECLARE_UNIQUE_INDEX(pg_proc_proname_args_nsp_index on pg_proc using btree(proname name_ops, pronargs int2_ops, proargtypes oidvector_ops, pronamespace oid_ops));
  /* This following index is not used for a cache and is not unique */
- DECLARE_INDEX(pg_relcheck_rcrelid_index on pg_relcheck using btree(rcrelid oid_ops));
  DECLARE_UNIQUE_INDEX(pg_rewrite_oid_index on pg_rewrite using btree(oid oid_ops));
  DECLARE_UNIQUE_INDEX(pg_rewrite_rel_rulename_index on pg_rewrite using btree(ev_class oid_ops, rulename name_ops));
  DECLARE_UNIQUE_INDEX(pg_shadow_usename_index on pg_shadow using btree(usename name_ops));
--- 183,188 ----
***************
*** 190,195 ****
--- 196,206 ----
  DECLARE_UNIQUE_INDEX(pg_trigger_oid_index on pg_trigger using btree(oid oid_ops));
  DECLARE_UNIQUE_INDEX(pg_type_oid_index on pg_type using btree(oid oid_ops));
  DECLARE_UNIQUE_INDEX(pg_type_typname_nsp_index on pg_type using btree(typname name_ops, typnamespace oid_ops));
+ 
+ /* This following index is not used for a cache and is not unique */
+ DECLARE_INDEX(pg_depend_depender_index on pg_depend using btree(classid oid_ops, objid oid_ops, objsubid int4_ops));
+ /* This following index is not used for a cache and is not unique */
+ DECLARE_INDEX(pg_depend_dependee_index on pg_depend using btree(depclassid oid_ops, depobjid oid_ops, depobjsubid int4_ops));
  
  /* last step of initialization script: build the indices declared above */
  BUILD_INDICES
Index: src/include/catalog/pg_proc.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/catalog/pg_proc.h,v
retrieving revision 1.241
diff -c -r1.241 pg_proc.h
*** src/include/catalog/pg_proc.h	2002/06/11 15:41:37	1.241
--- src/include/catalog/pg_proc.h	2002/06/15 16:39:38
***************
*** 94,99 ****
--- 94,102 ----
  #define Anum_pg_proc_probin				19
  #define Anum_pg_proc_proacl				20
  
+ /* Make the below functions permenant */
+ PINTABLE(1255);
+ 
  /* ----------------
   *		initial contents of pg_proc
   * ----------------
***************
*** 2171,2176 ****
--- 2174,2182 ----
  DESCR("greater-than-or-equal");
  
  /* System-view support functions */
+ DATA(insert OID = 1387 (  pg_get_fkeydef       PGNSP PGUID 12 f f f t f s 2 25 "26 19" 100 0 0 100  pg_get_fkeydef - _null_ ));
+ DESCR("alter table foreign key creation statement");
+ 
  DATA(insert OID = 1573 (  pg_get_ruledef	   PGNSP PGUID 12 f f f t f s 1 25 "26" 100 0 0 100  pg_get_ruledef - _null_ ));
  DESCR("source text of a rule");
  DATA(insert OID = 1640 (  pg_get_viewdef	   PGNSP PGUID 12 f f f t f s 1 25 "25" 100 0 0 100  pg_get_viewdef_name - _null_ ));
Index: src/include/catalog/pg_type.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/catalog/pg_type.h,v
retrieving revision 1.122
diff -c -r1.122 pg_type.h
*** src/include/catalog/pg_type.h	2002/04/25 02:56:56	1.122
--- src/include/catalog/pg_type.h	2002/06/15 16:39:41
***************
*** 228,233 ****
--- 228,235 ----
  #define Anum_pg_type_typdefaultbin		22
  #define Anum_pg_type_typdefault			23
  
+ /* Make the below types permenant */
+ PINTABLE(1247);
  
  /* ----------------
   *		initial contents of pg_type
Index: src/include/commands/comment.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/commands/comment.h,v
retrieving revision 1.11
diff -c -r1.11 comment.h
*** src/include/commands/comment.h	2002/04/09 20:35:54	1.11
--- src/include/commands/comment.h	2002/06/15 16:39:41
***************
*** 27,33 ****
  
  extern void CommentObject(CommentStmt *stmt);
  
! extern void DeleteComments(Oid oid, Oid classoid);
  
  extern void CreateComments(Oid oid, Oid classoid, int32 subid, char *comment);
  
--- 27,33 ----
  
  extern void CommentObject(CommentStmt *stmt);
  
! extern void DeleteComments(Oid oid, Oid classoid, int32 subid);
  
  extern void CreateComments(Oid oid, Oid classoid, int32 subid, char *comment);
  
Index: src/include/commands/defrem.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/commands/defrem.h,v
retrieving revision 1.38
diff -c -r1.38 defrem.h
*** src/include/commands/defrem.h	2002/05/22 21:40:55	1.38
--- src/include/commands/defrem.h	2002/06/15 16:39:41
***************
*** 29,35 ****
  			bool primary,
  			Expr *predicate,
  			List *rangetable);
! extern void RemoveIndex(RangeVar *relation);
  extern void ReindexIndex(RangeVar *indexRelation, bool force);
  extern void ReindexTable(RangeVar *relation, bool force);
  extern void ReindexDatabase(const char *databaseName, bool force, bool all);
--- 29,35 ----
  			bool primary,
  			Expr *predicate,
  			List *rangetable);
! extern void RemoveIndex(RangeVar *relation, int behavior);
  extern void ReindexIndex(RangeVar *indexRelation, bool force);
  extern void ReindexTable(RangeVar *relation, bool force);
  extern void ReindexDatabase(const char *databaseName, bool force, bool all);
***************
*** 39,55 ****
   */
  
  extern void CreateFunction(CreateFunctionStmt *stmt);
! extern void RemoveFunction(List *functionName, List *argTypes);
  
  extern void DefineOperator(List *names, List *parameters);
  extern void RemoveOperator(List *operatorName,
! 						   TypeName *typeName1, TypeName *typeName2);
  
  extern void DefineAggregate(List *names, List *parameters);
! extern void RemoveAggregate(List *aggName, TypeName *aggType);
  
  extern void DefineType(List *names, List *parameters);
! extern void RemoveType(List *names);
  extern void DefineDomain(CreateDomainStmt *stmt);
  extern void RemoveDomain(List *names, int behavior);
  
--- 39,58 ----
   */
  
  extern void CreateFunction(CreateFunctionStmt *stmt);
! extern void RemoveFunction(List *functionName, List *argTypes, int behavior);
! extern void RemoveFunctionById(Oid funcOid, int behavior);
  
  extern void DefineOperator(List *names, List *parameters);
  extern void RemoveOperator(List *operatorName,
! 						   TypeName *typeName1, TypeName *typeName2, int behavior);
! extern void RemoveOperatorById(Oid operOid, int behavior);
  
  extern void DefineAggregate(List *names, List *parameters);
! extern void RemoveAggregate(List *aggName, TypeName *aggType, int behavior);
  
  extern void DefineType(List *names, List *parameters);
! extern void RemoveType(List *names, int behavior);
! extern void RemoveTypeByTypeName(TypeName *typename, int behavior);
  extern void DefineDomain(CreateDomainStmt *stmt);
  extern void RemoveDomain(List *names, int behavior);
  
Index: src/include/commands/tablecmds.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/commands/tablecmds.h,v
retrieving revision 1.4
diff -c -r1.4 tablecmds.h
*** src/include/commands/tablecmds.h	2002/04/30 01:24:52	1.4
--- src/include/commands/tablecmds.h	2002/06/15 16:39:41
***************
*** 48,54 ****
  
  extern Oid	DefineRelation(CreateStmt *stmt, char relkind);
  
! extern void RemoveRelation(const RangeVar *relation);
  
  extern void TruncateRelation(const RangeVar *relation);
  
--- 48,54 ----
  
  extern Oid	DefineRelation(CreateStmt *stmt, char relkind);
  
! extern void RemoveRelation(const RangeVar *relation, int behavior);
  
  extern void TruncateRelation(const RangeVar *relation);
  
Index: src/include/commands/trigger.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/commands/trigger.h,v
retrieving revision 1.35
diff -c -r1.35 trigger.h
*** src/include/commands/trigger.h	2002/04/26 19:29:47	1.35
--- src/include/commands/trigger.h	2002/06/15 16:39:41
***************
*** 101,109 ****
  #define RI_MAX_ARGUMENTS		(RI_FIRST_ATTNAME_ARGNO + (RI_MAX_NUMKEYS * 2))
  
  
! extern void CreateTrigger(CreateTrigStmt *stmt);
! extern void DropTrigger(Oid relid, const char *trigname);
! extern void RelationRemoveTriggers(Relation rel);
  
  extern void renametrig(Oid relid, const char *oldname, const char *newname);
  
--- 101,110 ----
  #define RI_MAX_ARGUMENTS		(RI_FIRST_ATTNAME_ARGNO + (RI_MAX_NUMKEYS * 2))
  
  
! extern Oid CreateTrigger(CreateTrigStmt *stmt);
! extern char *getTriggerName(Oid relId, char *prefix);
! extern void DropTrigger(Oid relid, const char *trigname, int behavior);
! extern void DropTriggerById(Oid trigId, int behavior);
  
  extern void renametrig(Oid relid, const char *oldname, const char *newname);
  
Index: src/include/commands/view.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/commands/view.h,v
retrieving revision 1.14
diff -c -r1.14 view.h
*** src/include/commands/view.h	2002/03/29 19:06:22	1.14
--- src/include/commands/view.h	2002/06/15 16:39:41
***************
*** 17,22 ****
  #include "nodes/parsenodes.h"
  
  extern void DefineView(const RangeVar *view, Query *view_parse);
! extern void RemoveView(const RangeVar *view);
  
  #endif   /* VIEW_H */
--- 17,22 ----
  #include "nodes/parsenodes.h"
  
  extern void DefineView(const RangeVar *view, Query *view_parse);
! extern void RemoveView(const RangeVar *view, int behavior);
  
  #endif   /* VIEW_H */
